/*
------------------------------------------------------------------------
  Programme: THAGO.C

  Module   : Programme principal
			      Borland Turbo C++

  Auteur   : Jean Philippe BOCQUENET

  Date     : 15/V/1994

  Objet    : Programme d'aide au  positionnement  d'un  point dans le
	     quadrillage.
	     Ce programme permet de coter en X,Y un point par rapport
	     au quadrillage gnral du site,  l'aide de deux doubles
	     dcamtres (triangulation).

-----------------------------------------------------------------------
*/

#include <dos.h>
#include <math.h>
#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>

#define F1            		0x3B00
#define F2  	      		0x3c00
#define F3  	      		0x3d00
#define F4  	      		0x3e00
#define F5  	      		0x3f00
#define F9  	      		0x4300
#define F10 	      		0x4400
#define SHIFT_F10     		0x5d00



/* --------------------------------------------------------- */
void bordure(int color)
{
  union REGS regs;
  regs.h.ah = 0x10;
  regs.h.al = 1;
  regs.h.bh = color & 15;
  int86(0x10, &regs, &regs);
}

/* --------------------------------------------------------- */
void logo()
{
  int x=18;
  int y=1;

  bordure(1);
  window(1,1,80,25); textbackground(BLACK);  clrscr();  textcolor(BLUE);
  gotoxy( 1,3);  cprintf("                                                                      ");

  gotoxy( 1,5);  cprintf("                                                                      ");

  gotoxy( 1,7);  cprintf("                                                            ");
  gotoxy( 1,8);  cprintf("                                                            ");
  gotoxy( 1,9);  cprintf("                                        ");
  gotoxy( 1,10); cprintf("                                        ");
  gotoxy( 1,11); cprintf(" Version 1.20 ");
  gotoxy( 1,12); cprintf("");
  textcolor(LIGHTGREEN);
  gotoxy(x+16, y);  cprintf("Ŀ");
  gotoxy(x, y+ 1);  cprintf(" ͻ");
  gotoxy(x, y+ 2);  cprintf(" Ŀ   ĿĿĿ ");
  gotoxy(x, y+ 3);  cprintf("   Ŀ       ");
  gotoxy(x, y+ 4);  cprintf("           Ŀ   ");
  gotoxy(x, y+ 5);  cprintf("                 ");
  gotoxy(x, y+ 6);  cprintf("               ");
  gotoxy(x, y+ 7);  cprintf("               ");
  gotoxy(x, y+ 8);  cprintf(" ͼ");
  gotoxy(x+25, y+ 9);  cprintf(" (c)-1994");
  window(1,13,80,25); textbackground(BLUE); textcolor(WHITE); clrscr(); window(1,1,80,25);
}

void menu(void)
{
  logo();
  textcolor(WHITE);
  gotoxy(10,14); cprintf("[F1] - Nom du carr d'origine (Ref. X,Y)");
  gotoxy(10,16); cprintf("[F2] - Points de triangulation");
  gotoxy(10,18); cprintf("[F3] - Refrences sur les axes et distance de la base");
  gotoxy(10,20); cprintf("[F4] - Calculs du carr et des coordonnes");
  textcolor(YELLOW);
  gotoxy(10,24); cprintf("[SHIFT][F10] - Quitter");
  textcolor(LIGHTGREEN);
  gotoxy(48,24); cprintf("Auteur : Jean Philippe BOCQUENET");
  textcolor(WHITE);
}

void schema(void)
{
  textcolor(BLACK);
  gotoxy(56,17); cprintf("   Pt3           Pt4");
  gotoxy(56,18); cprintf("     Ŀ     N");
  gotoxy(56,19); cprintf("                     ");
  gotoxy(56,20); cprintf("          /\\         ");
  gotoxy(56,21); cprintf("      d1/    \\d2");
  gotoxy(56,22); cprintf("y     /        \\");
  gotoxy(56,23); cprintf("x  ");
  gotoxy(56,24); cprintf("   Pt1    base   Pt2");
  textcolor(WHITE);
}

/* --------------------------------------------------------- */
void lecture_disc(char carre, int xcarre, int ycarre)
{
  int bccol, bclig;

  FILE *fic;

  fic = fopen("ESSAI.THA","a+t");
  fscanf(fic,"%s,	",carre);
  fscanf(fic,"%d, %d",xcarre,ycarre);
  fclose(fic);
}


void main(void)
{
  FILE *fic;
  unsigned int touche;
  int axe1, axe2, point1, point2, sens;
  int chiffre, inter;
  int xcarre, ycarre;
  int dec, sign;
  int numero;
  int numero2,xcarre2,ycarre2;
  char carretemp[30];
  double ptref_axe, ptref1, ptref2;
  double distance, indice;
  double longinter, long1, long2;
  double longaxe1, longaxe2, interlongaxe2;
  double xcoord, ycoord, x, y;
  double carre1, carre2;
  double xcar, ycar;
  char lettre, lettre2[8];
  char *ptr;
  char *string="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  char carre[30], string2[30];

  fic = fopen("ESSAI.THA","a+t");
 _setcursortype(_NOCURSOR);

 for(;;)
 {
  clrscr();
  menu();
  touche = bioskey(0);
  switch(touche)
 {
  case F1:
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,24); cprintf("     A B C DEF... .  ");
	textcolor(WHITE);
	gotoxy(2,13);
	printf("Entrez la lettre de dpart du carroyage (abscisses)(A,B,C,..) : ");
	lettre = getchar();
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(56,24); cprintf("     A B C DEF... .  ");

	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,20); cprintf(" . ");
	gotoxy(56,21); cprintf(" 3 ");
	gotoxy(56,22); cprintf(" 2 ");
	gotoxy(56,23); cprintf(" 1 ");
	textcolor(WHITE);

	gotoxy(2,15);
	printf("Entrez le chiffre de dpart du carroyage (ordonnes)(1,2,3,.) : ");
	lettre2[0]=6;
	ptr=cgets(lettre2);
	chiffre = atoi(ptr);
	fflush(stdin);
	textcolor(WHITE);
	_setcursortype(_NOCURSOR);
	break;

  case F2:
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,24); cprintf("   Pt1");
	textcolor(WHITE);
	gotoxy(5,14);
	printf("1er point de triangulation (1,2,3,..) : ");
	scanf("%d",&point1);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(56,24); cprintf("   Pt1");
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(73,24); cprintf("Pt2");
	textcolor(WHITE);
	gotoxy(5,16);
	printf("2em point de triangulation (1,2,3,..) : ");
	scanf("%d",&point2);
	fflush(stdin);
	textcolor(WHITE);
	if ((point1==1 && point2==2) || (point1==3 && point2==1) || \
	(point1==4 && point2==3) || (point1==2 && point2==4)) {sens=1;}
	if ((point1==2 && point2==1) || (point1==1 && point2==3) || \
	(point1==3 && point2==4) || (point1==4 && point2==2)) {sens=2;}
	_setcursortype(_NOCURSOR);
	break;

  case F3:
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(60,23); cprintf("");
	textcolor(WHITE);
	gotoxy(5,14);
	printf("Point de ref. sur l'axe des ordonnes : ");
	scanf("%lf",&ptref_axe);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(56,23); cprintf("x  ");
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,24); cprintf("                    ");
	textcolor(WHITE);
	gotoxy(10,18);
	printf("Point de dpart sur l'axe des abscisses : ");
	scanf("%lf",&ptref1);
	fflush(stdin);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,24); cprintf("                    ");
	textcolor(WHITE);
	gotoxy(10,19);
	printf("Point de  fin  sur  l'axe des abscisses : ");
	scanf("%lf",&ptref2);
	fflush(stdin);
	distance = ptref2-ptref1;
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,24); cprintf("          base       ");
	textcolor(WHITE);
	gotoxy(10,21);
	printf("Distance entre les points : %2.0f m.",distance);
	_setcursortype(_NOCURSOR);
	getch();
	break;

  case F4:
      do
       {
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(63,20); cprintf("    /");
	gotoxy(63,21); cprintf("d1/  ");
	gotoxy(63,22); cprintf("/    ");
	textcolor(WHITE);
	gotoxy(5,14);
	printf("Premire mesure ( partir du point %d ) : ",point1);
	scanf("%lf",&long1);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(63,20); cprintf("    /");
	gotoxy(63,21); cprintf("d1/  ");
	gotoxy(63,22); cprintf("/    ");
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(68,20); cprintf("\\    ");
	gotoxy(68,21); cprintf("  \\d2");
	gotoxy(68,22); cprintf("    \\");
	textcolor(WHITE);
	gotoxy(5,16);
	printf("Deuxime mesure ( partir du point %d ) : ",point2);
	scanf("%lf",&long2);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(68,20); cprintf("\\    ");
	gotoxy(68,21); cprintf("  \\d2");
	gotoxy(68,22); cprintf("    \\");
	textcolor(WHITE);

/* Squence de calcul des coordonnes x,y */
	if(sens==2)
	{ longinter=long1; long1=long2; long2=longinter; }
	indice = 1;
	longaxe1 = (((pow(long1,2)-pow(long2,2))+pow(distance,2))/distance)/2;
	interlongaxe2 = pow(long1,2)-pow(longaxe1,2);

	if (interlongaxe2 >= 0)
	{
	   longaxe2 = sqrt(interlongaxe2 * indice);
	   xcoord=ptref_axe+longaxe2;
	   ycoord=ptref1+longaxe1;

	   if ((point1==1 && point2==2) || (point1==2 && point2==1))
		{x=ycoord; y=xcoord;}
	   if ((point1==2 && point2==4) || (point1==4 && point2==2))
		{x=distance-xcoord; y=ycoord;}
	   if ((point1==3 && point2==1) || (point1==1 && point2==3))
		{x=xcoord; y=distance-ycoord;}
	   if ((point1==4 && point2==3) || (point1==3 && point2==4))
		{x=distance-ycoord; y=distance-xcoord;}

/* calcul la lettre du carr */
	   xcar=modf(x, &carre1);
	   ptr=strchr(string,lettre);
	   inter=(ptr-string);
	   carre1 += inter+1;
	   strncpy(string2,string,carre1);
	   string2[carre1]='\0';
	   strrev(string2);
	   strncpy(carre,string2,1);
	   carre[1]='\0';

/* calcul le chiffre du carr */
	   ycar=modf(y, &carre2);
	   carre2 += chiffre;
	   ptr=(char *)fcvt(carre2,5,&dec,&sign);
	   strncpy(string2,ptr,dec);
	   string2[dec]='\0';

/* Cr le nom du carr (ex : A4) */
	   strcat(carre,string2);
	   xcar=xcar*100; xcarre=(int)xcar;
	   ycar=ycar*100; ycarre=(int)ycar;

/* Affichage des donnes */
	   textcolor(YELLOW);
	   gotoxy(8,18); cprintf("ͻ");
	   gotoxy(8,19); cprintf("                       ");
	   gotoxy(8,20); cprintf("                       ");
	   gotoxy(8,21); cprintf("                       ");
	   gotoxy(8,22); cprintf("                       ");
	   gotoxy(8,23); cprintf("ͼ");
	   textcolor(LIGHTMAGENTA);
	   gotoxy(10,19); cprintf("CARRE : %s",carre);
	   textcolor(WHITE);
	   gotoxy(10,21); cprintf("Coordonne X : %d",xcarre);
	   gotoxy(10,22); cprintf("Coordonne Y : %d",ycarre);
	   numero=1;

	   fseek(fic,0L,SEEK_SET);
	   do {
		fscanf(fic,"%d,%d,%d,%s",&numero2,&xcarre2,&ycarre2,carretemp);
		ptr=(char *)strcmp(carretemp,carre);
		if(ptr == 0)
		 { numero=numero2+1; }
	      } while(!feof(fic));

	   gotoxy(10,20); cprintf("Numro : %d",numero);

	   fseek(fic,0L,SEEK_END);
	   fprintf(fic,"%3d,	",numero);
	   fprintf(fic,"%3d,	%3d,	",xcarre,ycarre);
	   fprintf(fic,"%6s\n",carre);
	}
	else
	{ x=0; y=0;
	  textcolor(LIGHTRED);
	  gotoxy(5,22);
	  cprintf("Erreure !!! Les deux mesures sont plus courtes que");
	  gotoxy(5,23);
	  cprintf("la distance entre les deux points de rfrence !");
	  textcolor(WHITE);
	}
	  _setcursortype(_NOCURSOR);
	  textcolor(LIGHTRED);
	  gotoxy(5,25);
	  cprintf("[ESC] - Sortie / Autre touche pour continuer");

       } while(getch()!=27);
       break;

/* Sortie du programme */
  case SHIFT_F10:

	fclose(fic);
	_setcursortype(_NORMALCURSOR);
	textbackground(BLACK); textcolor(WHITE);
	bordure(1);
	clrscr();
	exit(0);
  }
 }
}
